<template>
    <div class="box p-5 md:p-8 mb-10">
        <form @submit.prevent="form.post(`/employee/user/${user.id}`, {preserveScroll: true})">
            <h3>Edit User</h3>

            <div class="w-full flex justify-center items-center ">
                <div class="flex w-full mb-2">
                    <div class="md:flex flex-grow">
                        <div class="flex flex-col w-full md:w-1/2 mr-2">
                            <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                                Name</label>
                            <input id="name" class="input w-full" type="text" placeholder="Enter name"
                                v-model="form.name" />
                            <div v-if="form.errors.name" class="text-error">
                                {{ form.errors.name }}
                            </div>
                        </div>
                        <div class="flex flex-col w-full md:w-1/2">
                            <label for="gender" class="text-sm font-medium text-gray-700 mb-2 mt-5">Gender</label>
                            <select id="gender" class="dropdown w-full" v-model="form.gender">
                                <option value="Male">Male</option>
                                <option value="Female">Female</option>
                                <option value="Other">Other</option>
                            </select>
                            <div v-if="form.errors.gender" class="text-error">
                                {{ form.errors.gender }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>


            <div class="w-full flex justify-center items-center ">
                <div class="flex w-full mb-2">
                    <div class="md:flex flex-grow">
                        <div class="flex flex-col w-full">
                            <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">Email
                            </label>
                            <input id="employee-name" class="input w-full" type="email" placeholder="Enter Email"
                                v-model="form.email" />
                            <div v-if="form.errors.email" class="text-error">
                                {{ form.errors.email }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="w-full flex justify-center items-center ">
                <div class="flex w-full mb-2">
                    <div class="md:flex flex-grow">
                        <div class="flex flex-col w-full md:w-1/2 mr-2">
                            <label for="department"
                                class="text-sm font-medium text-gray-700 mb-2 mt-5">Nationality</label>
                            <select id="Nationality" class="dropdown w-full" v-model="form.nationality">
                                <option value="Bhutanese">Bhutanese</option>
                                <option value="Foreigner">Foreigner</option>
                            </select>
                            <div v-if="form.errors.nationality" class="text-error">
                                {{ form.errors.nationality }}
                            </div>
                        </div>
                        <div class="flex flex-col w-full md:w-1/2">
                            <label for="employee-name" class="text-sm font-medium text-gray-700 mb-2 mt-5">Foreign
                                Nationality
                            </label>
                            <input id="employee-name" class="input w-full" placeholder="eg: Indian"
                                :disabled="form.nationality === 'Bhutanese'" v-model="form.foreign_nationality" />
                            <div v-if="form.errors.foreign_nationality" class="text-error">
                                {{ form.errors.foreign_nationality }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="w-full flex justify-center items-center ">
                <div class="flex w-full mb-2">
                    <div class="md:flex flex-grow">
                        <div class="flex flex-col w-full md:w-1/2 mr-2">
                            <label for="dob" class="text-sm font-medium text-gray-700 mb-2 mt-5">Date of Birth
                            </label>
                            <input class="input w-full" type="date" v-model="form.dob" />
                            <div v-if="form.errors.dob" class="text-error">
                                {{ form.errors.dob }}
                            </div>
                        </div>
                        <div class="flex flex-col w-full md:w-1/2">
                            <label for="doj" class="text-sm font-medium text-gray-700 mb-2 mt-5">Date of Join</label>
                            <input class="input w-full" type="date" v-model="form.doj" />
                            <div v-if="form.errors.doj" class="text-error">
                                {{ form.errors.doj }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>


            <div class="w-full flex justify-center items-center ">
                <div class="flex w-full mb-2">
                    <div class="md:flex flex-grow">
                        <div class="flex flex-col w-full">
                            <label for="cid" class="text-sm font-medium text-gray-700 mb-2 mt-5">CID</label>
                            <input id="cid" class="input w-full" placeholder="Enter CID" v-model="form.cid" />
                            <div v-if="form.errors.cid" class="text-error">
                                {{ form.errors.cid }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>




            <div class="w-full flex justify-center items-center ">
                <div class="flex w-full mb-2">
                    <div class="md:flex flex-grow">
                        <div class="flex flex-col w-full md:w-1/2 mr-2">
                            <label for="department" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                                Department</label>
                            <select id="department" class="dropdown w-full" v-model="form.department">
                                <option>No Department</option>
                                <option v-for="department in departments" :value="department.id">{{ department.name }}
                                </option>
                            </select>
                            <div v-if="form.errors.department" class="text-error">
                                {{ form.errors.department }}
                            </div>
                        </div>
                        <div class="flex flex-col w-full md:w-1/2">
                            <label for="designation" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                                Designation</label>
                            <input id="designation" v-model="form.designation"
                                :disabled="form.department === 'No Department'" class="input w-full"
                                placeholder="Enter Text" />
                            <div v-if="form.errors.designation" class="text-error">
                                {{ form.errors.designation }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="w-full flex justify-center items-center ">
                <div class="flex w-full mb-2">
                    <div class="md:flex flex-grow">
                        <div class="flex flex-col w-full">
                            <label for="department" class="text-sm font-medium text-gray-700 mb-2 mt-5">
                                Role</label>
                            <select v-model="form.role_id" id="department" class="dropdown w-full">
                                <option v-for="role in roles" :value="role.id">{{ role.name }}</option>
                            </select>
                            <div v-if="form.errors.role_id" class="text-error">
                                {{ form.errors.role_id }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Dynamic fields -->
            <div v-if="roleFields.length > 0">
                <div class="text-base font-bold text-gray-700 mb-3 mt-5">Master details (Fields with <span
                        class="text-orange-500">*</span> means that it is required)</div>
                <div class="space-y-7">
                    <div v-for="(roleField, index) in roleFields">
                        <label class="block text-base font-medium text-gray-700"
                            :class="{ 'opacity-30': roleField.foreigner_field && form.nationality === 'Bhutanese' }">{{
                                index + 1 }}.{{ roleField.field.name }}
                            <span v-if="roleField.foreigner_field" class="text-orange-500">(Only for foreigners)</span>
                            <span v-if="roleField.field.required" class="text-lg text-orange-500">*</span>
                        </label>
                        <fieldset class="mb-1"
                            :disabled="roleField.foreigner_field && form.nationality === 'Bhutanese'">
                            <input v-model="form.filled_role_fields[index].value" class="w-full input" type="text"
                                v-if="roleField.field.type === 'Text'" />
                            <input v-model="form.filled_role_fields[index].value" class="w-full input" type="number"
                                v-else-if="roleField.field.type === 'Number'" />
                            <input v-model="form.filled_role_fields[index].value" class="w-full input" type="date"
                                v-else-if="roleField.field.type === 'Date'" />
                            <div v-else-if="roleField.field.type === 'File'">
                                <div v-if="form.filled_role_fields[index].file">
                                    <div class="flex items-center gap-3"
                                        :class="{ 'opacity-30': form.filled_role_fields[index].delete }">
                                        <Icon icon="fa-solid fa-file" class="text-gray-600 text-4xl"></Icon>
                                        <div>{{ roleField.field.name }}.{{
                                            form.filled_role_fields[index].file.filename.split('.').pop() }}</div>
                                    </div>
                                    <div>
                                        <input type="checkbox" class="checkbox"
                                            v-model="form.filled_role_fields[index].delete" /><label
                                            class="text-sm ms-2">Delete old file</label>
                                    </div>
                                    <div class="mt-4 text-sm"
                                        :class="{ 'opacity-30': !form.filled_role_fields[index].delete }">Pick another
                                        file</div>
                                    <input :disabled="!form.filled_role_fields[index].delete"
                                        @change="(event) => form.filled_role_fields[index].value = event.target.files[0]"
                                        class="w-full input-file" type="file" />
                                </div>
                                <input v-else
                                    @change="(event) => form.filled_role_fields[index].value = event.target.files[0]"
                                    class="w-full input-file" type="file" />
                            </div>
                            <textarea v-model="form.filled_role_fields[index].value" class="w-full textarea"
                                v-else-if="roleField.field.type === 'Text Area'" />
                            <div v-else-if="roleField.field.type === 'Checkbox'">
                                <fieldset v-for="option in roleField.field.options">
                                    <input v-model="form.filled_role_fields[index].value" :value="option.id"
                                        type="checkbox" class="checkbox">
                                    <label class="text-sm ms-2">{{ option.value }}</label>
                                </fieldset>
                            </div>
                            <div v-else-if="roleField.field.type === 'Radio Button'">
                                <fieldset v-for="option in roleField.field.options">
                                    <input v-model="form.filled_role_fields[index].value" :value="option.id"
                                        type="radio" class="radio">
                                    <label class="text-sm ms-2">{{ option.value }}</label>
                                </fieldset>
                            </div>
                            <select v-model="form.filled_role_fields[index].value" class="w-full dropdown"
                                v-else-if="roleField.field.type === 'Dropdown'">
                                <option v-for="option in roleField.field.options">
                                    {{ option.value }}
                                </option>
                            </select>
                            <!-- error -->
                            <div v-if="form.errors[`${roleField.id}id`]" class="text-error">
                                {{ form.errors[`${roleField.id}id`] }}
                            </div>
                        </fieldset>
                        <div class="text-sm flex flex-col md:flex-row gap-x-5">
                            <!-- <label>Field type: <span class="text-orange-500">{{ roleField.field.type }}</span></label> -->
                            <!-- <label>Issuable: <span class="text-orange-500">{{ roleField.issuable ? 'True' : 'False' }}</span></label>
                <label>Alertable: <span class="text-orange-500">{{ roleField.alertable ? 'True' : 'False' }}</span></label>
                <label v-if="roleField.alertable">Alert period: <span class="text-orange-500">{{ roleField.alert_period }}</span></label> -->
                            <label v-if="roleField.issuable" class="text-orange-500 font-semibold">
                                <Icon icon="fa-solid fa-hand-holding-hand"></Icon> Issuable
                            </label>
                            <label v-if="roleField.alertable" class="text-orange-500 font-semibold">
                                <Icon icon="fa-solid fa-circle-exclamation"></Icon> Alert ({{ roleField.alert_period }})
                            </label>
                        </div>
                    </div>
                </div>
            </div>

            <div class="flex gap-x-3 mt-3 flex-row-reverse">
                <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2">Save</button>
    <Link href="/employee/user" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">Cancel</Link>
     
            </div>
        </form>
    </div>
</template>

<script setup>
import { useForm, Link } from '@inertiajs/vue3';
import { ref, watch } from 'vue';

const props = defineProps({
    roles: Array,
    user: Object
})

const roleFields = ref(props.roles.find((role) => role.id == props.user.role_id).fields.sort((roleFieldA, roleFieldB) => roleFieldA.field.index - roleFieldB.field.index));

const form = useForm({
    _method: 'put',
    name: props.user.name,
    gender: props.user.gender,
    email: props.user.email,
    nationality: props.user.nationality,
    foreign_nationality: props.user.foreign_nationality,
    dob: props.user.dob,
    doj: props.user.doj,
    cid: props.user.cid,
    role_id: props.user.role_id,
    department: props.user.department_staff_detail?.department_id ?? 'No Department',
    designation: props.user.department_staff_detail?.designation ?? '',
    filled_role_fields: props.roles.find((role) => role.id == props.user.role_id).fields.sort((roleFieldA, roleFieldB) => roleFieldA.field.index - roleFieldB.field.index).map(
        (roleField) => roleField.field.type === 'Checkbox' ? { roleField: roleField, value: props.user.filled_role_fields.find((filled_role_field) => roleField.id === filled_role_field.role_field_id)?.selected_options.map((selected_option) => selected_option.id) ?? [] } :
            roleField.field.type === 'File' ? { roleField: roleField, value: "", file: props.user.filled_role_fields.find((filled_role_field) => roleField.id === filled_role_field.role_field_id)?.file ?? null, delete: false, id: props.user.filled_role_fields.find((filled_role_field) => roleField.id === filled_role_field.role_field_id)?.id ?? null } :
                { roleField: roleField, value: props.user.filled_role_fields.find((filled_role_field) => roleField.id === filled_role_field.role_field_id)?.value ?? null })
});


watch(() => form.role_id, (value) => {
    //update current role fields
    var targetFields = props.roles.find((role) => role.id === value).fields
    targetFields.forEach(roleField => {
        if (roleField.field.type === 'Checkbox' || roleField.field.type === 'Radio Button' || roleField.field.type === 'Dropdown') {
            roleField.field.options.sort((optionA, optionB) => optionA.index - optionB.index);
        }
    });
    roleFields.value = targetFields.sort((roleFieldA, roleFieldB) => roleFieldA.field.index - roleFieldB.field.index);

    //refresh values in forms
    form.filled_role_fields = new Array(targetFields.length);
    roleFields.value.forEach((roleField, index) => {
        if (value === props.user.role_id) {
            if (roleField.field.type === 'Checkbox') {
                form.filled_role_fields[index] = { roleField: roleField, value: props.user.filled_role_fields.find((filled_role_field) => roleField.id === filled_role_field.role_field_id)?.selected_options.map((selected_option) => selected_option.id)  ?? [] };
            } else if (roleField.field.type === 'File') {
                form.filled_role_fields[index] = { roleField: roleField, value: null, file: props.user.filled_role_fields.find((filled_role_field) => roleField.id === filled_role_field.role_field_id)?.file ?? null, delete: false, id: props.user.filled_role_fields.find((filled_role_field) => roleField.id === filled_role_field.role_field_id)?.id ?? null };
            } else {
                form.filled_role_fields[index] = { roleField: roleField, value: props.user.filled_role_fields.find((filled_role_field) => roleField.id === filled_role_field.role_field_id)?.value ?? null };
            }
        }
        else {
            var frf = props.user.filled_role_fields.find((filled_role_field) => roleField.field.type === filled_role_field.role_field.field.type && roleField.field.name === filled_role_field.role_field.field.name);

            if (frf) {
                if (roleField.field.type === 'Checkbox') {
                    var newCbIds = []
                    frf.selected_options.forEach((selected_option) => {
                        var newSelectOption = roleField.field.options.find((option) => option.value === selected_option.value);
                        if(newSelectOption){
                            newCbIds.push(newSelectOption.id);
                        }
                    })
                    form.filled_role_fields[index] = { roleField: roleField, value: newCbIds };
                } else if (roleField.field.type === 'File') {
                    form.filled_role_fields[index] = { roleField: roleField, value: frf.value, file: frf.file, delete: false, id: frf.id };
                } else {
                    form.filled_role_fields[index] = { roleField: roleField, value: frf.value };
                }
            } else {
                if (roleField.field.type === 'Checkbox') {
                    form.filled_role_fields[index] = { roleField: roleField, value: [] };
                } else if (roleField.field.type === 'File') {
                    form.filled_role_fields[index] = { roleField: roleField, value: null, file: null, delete: false, id: null };
                } else {
                    form.filled_role_fields[index] = { roleField: roleField, value: null };
                }
            }

        }
    })
})
</script>